% Script che calcola e visualizza il polinomio di interpolazione 
% di un insieme di punti, mediante: 
% 1. un unico polinomio nella forma di Newton
% 2. un polinomio a tratti cubici (spline cubiche).
% interpola.m
% Legge in input il grado del polinomio interpolante,

n=input('Grado del polinomio interpolante ')
metodo=input('1) Punti equispaziati  2) Punti Chebychev')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%CASO punti di interpolazione con ascisse equispaziate e Ordinate 
%   date dalla valutazione della funzione 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
a=-pi; b=pi;
switch metodo
case 1
    % punti di interpolazione equispaziati
    x=linspace(a,b,n+1);
case 2    
    % punti di interpolazione zeri di Chebychev
    for i=1:n+1
        x(i)=-pi*cos(pi*(2*(i-1)+1)/(2*(n+1)));
    end
otherwise
    disp('Error')
end
y=fun1(x);
% punti di valutazione 
x1=[-pi:.01:pi];
yfun=fun1(x1);
% Interpolazione di Newton
c=InterpN(x,y);
yInt=HornerN(c,x,x1); %valutazione del polinomio
% Interpolazione spline
yInt1=spline(x,y,x1);
plot(x1,yInt1,x1,yInt,x,y,'ro',x1,yfun,'g')
title('Interpolazione')
legend('Interp. spline','Interp. Newton','(x_i,y_i)','Funz')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Ripetere per la funzione
% y=1/(1+x^2)'
% sostituendo 
%  fun1 [a,b]=[-pi,pi] con
%  funRunge [a,b]=[-5,5]
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%